<?php

namespace CTT\EnumType;

/**
 * This class stands for AddressTypeValues EnumType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AddressTypeValues
 * @subpackage Enumerations
 */
class AddressTypeValues
{
    /**
     * Constant for value 'Sender'
     * @return string 'Sender'
     */
    const VALUE_SENDER = 'Sender';
    /**
     * Constant for value 'Receiver'
     * @return string 'Receiver'
     */
    const VALUE_RECEIVER = 'Receiver';
    /**
     * Constant for value 'Return'
     * @return string 'Return'
     */
    const VALUE_RETURN = 'Return';
    /**
     * Constant for value 'SecondReceiver'
     * @return string 'SecondReceiver'
     */
    const VALUE_SECOND_RECEIVER = 'SecondReceiver';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_SENDER
     * @uses self::VALUE_RECEIVER
     * @uses self::VALUE_RETURN
     * @uses self::VALUE_SECOND_RECEIVER
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_SENDER,
            self::VALUE_RECEIVER,
            self::VALUE_RETURN,
            self::VALUE_SECOND_RECEIVER,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
