<?php

namespace CTT\EnumType;

/**
 * This class stands for SpecialServiceTypeValues EnumType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SpecialServiceTypeValues
 * @subpackage Enumerations
 */
class SpecialServiceTypeValues
{
    /**
     * Constant for value 'PostalObject'
     * @return string 'PostalObject'
     */
    const VALUE_POSTAL_OBJECT = 'PostalObject';
    /**
     * Constant for value 'AgainstReimbursement'
     * @return string 'AgainstReimbursement'
     */
    const VALUE_AGAINST_REIMBURSEMENT = 'AgainstReimbursement';
    /**
     * Constant for value 'NominativeCheck'
     * @return string 'NominativeCheck'
     */
    const VALUE_NOMINATIVE_CHECK = 'NominativeCheck';
    /**
     * Constant for value 'Saturday'
     * @return string 'Saturday'
     */
    const VALUE_SATURDAY = 'Saturday';
    /**
     * Constant for value 'ReturnDocumentSigned'
     * @return string 'ReturnDocumentSigned'
     */
    const VALUE_RETURN_DOCUMENT_SIGNED = 'ReturnDocumentSigned';
    /**
     * Constant for value 'SpecialInsurance'
     * @return string 'SpecialInsurance'
     */
    const VALUE_SPECIAL_INSURANCE = 'SpecialInsurance';
    /**
     * Constant for value 'Fragil'
     * @return string 'Fragil'
     */
    const VALUE_FRAGIL = 'Fragil';
    /**
     * Constant for value 'Back'
     * @return string 'Back'
     */
    const VALUE_BACK = 'Back';
    /**
     * Constant for value 'SecondScheduledDelivery'
     * @return string 'SecondScheduledDelivery'
     */
    const VALUE_SECOND_SCHEDULED_DELIVERY = 'SecondScheduledDelivery';
    /**
     * Constant for value 'SMS'
     * @return string 'SMS'
     */
    const VALUE_SMS = 'SMS';
    /**
     * Constant for value 'DeliveryPoint'
     * @return string 'DeliveryPoint'
     */
    const VALUE_DELIVERY_POINT = 'DeliveryPoint';
    /**
     * Constant for value 'AuthorizeReturn'
     * @return string 'AuthorizeReturn'
     */
    const VALUE_AUTHORIZE_RETURN = 'AuthorizeReturn';
    /**
     * Constant for value 'MultipleHomeDelivery'
     * @return string 'MultipleHomeDelivery'
     */
    const VALUE_MULTIPLE_HOME_DELIVERY = 'MultipleHomeDelivery';
    /**
     * Constant for value 'TimeWindow'
     * @return string 'TimeWindow'
     */
    const VALUE_TIME_WINDOW = 'TimeWindow';
    /**
     * Constant for value 'CertainDay'
     * @return string 'CertainDay'
     */
    const VALUE_CERTAIN_DAY = 'CertainDay';
    /**
     * Constant for value 'PhoneContact'
     * @return string 'PhoneContact'
     */
    const VALUE_PHONE_CONTACT = 'PhoneContact';
    /**
     * Constant for value 'LiveTracking'
     * @return string 'LiveTracking'
     */
    const VALUE_LIVE_TRACKING = 'LiveTracking';
    /**
     * Constant for value 'DeliveryAggregation'
     * @return string 'DeliveryAggregation'
     */
    const VALUE_DELIVERY_AGGREGATION = 'DeliveryAggregation';
    /**
     * Constant for value 'ContactoAgendamento'
     * @return string 'ContactoAgendamento'
     */
    const VALUE_CONTACTO_AGENDAMENTO = 'ContactoAgendamento';
    /**
     * Constant for value 'SaturdayShopping'
     * @return string 'SaturdayShopping'
     */
    const VALUE_SATURDAY_SHOPPING = 'SaturdayShopping';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_POSTAL_OBJECT
     * @uses self::VALUE_AGAINST_REIMBURSEMENT
     * @uses self::VALUE_NOMINATIVE_CHECK
     * @uses self::VALUE_SATURDAY
     * @uses self::VALUE_RETURN_DOCUMENT_SIGNED
     * @uses self::VALUE_SPECIAL_INSURANCE
     * @uses self::VALUE_FRAGIL
     * @uses self::VALUE_BACK
     * @uses self::VALUE_SECOND_SCHEDULED_DELIVERY
     * @uses self::VALUE_SMS
     * @uses self::VALUE_DELIVERY_POINT
     * @uses self::VALUE_AUTHORIZE_RETURN
     * @uses self::VALUE_MULTIPLE_HOME_DELIVERY
     * @uses self::VALUE_TIME_WINDOW
     * @uses self::VALUE_CERTAIN_DAY
     * @uses self::VALUE_PHONE_CONTACT
     * @uses self::VALUE_LIVE_TRACKING
     * @uses self::VALUE_DELIVERY_AGGREGATION
     * @uses self::VALUE_CONTACTO_AGENDAMENTO
     * @uses self::VALUE_SATURDAY_SHOPPING
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_POSTAL_OBJECT,
            self::VALUE_AGAINST_REIMBURSEMENT,
            self::VALUE_NOMINATIVE_CHECK,
            self::VALUE_SATURDAY,
            self::VALUE_RETURN_DOCUMENT_SIGNED,
            self::VALUE_SPECIAL_INSURANCE,
            self::VALUE_FRAGIL,
            self::VALUE_BACK,
            self::VALUE_SECOND_SCHEDULED_DELIVERY,
            self::VALUE_SMS,
            self::VALUE_DELIVERY_POINT,
            self::VALUE_AUTHORIZE_RETURN,
            self::VALUE_MULTIPLE_HOME_DELIVERY,
            self::VALUE_TIME_WINDOW,
            self::VALUE_CERTAIN_DAY,
            self::VALUE_PHONE_CONTACT,
            self::VALUE_LIVE_TRACKING,
            self::VALUE_DELIVERY_AGGREGATION,
            self::VALUE_CONTACTO_AGENDAMENTO,
            self::VALUE_SATURDAY_SHOPPING,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
